<script lang="ts">
import { MetaInfo } from 'vue-meta/types/vue-meta';
import Vue from 'vue';
import {
  BackgroundWrapper,
  NextStepAlt,
  SideNavigationVariant,
} from '../components/common/index.vue';
import Hero from '../components/why-gitlab/hero.vue';
import WhyGitLabContent from '../components/why-gitlab/content.vue';
import ProofPoints from '../components/why-gitlab/proof-points.vue';
import { getPageMetadata } from '~/common/meta';
import { getClient } from '~/plugins/contentful';
import { CONTENT_TYPES } from '~/common/content-types';
import { convertToCaseSensitiveLocale } from '~/common/util';

export default Vue.extend({
  components: {
    NextStepAlt,
    BackgroundWrapper,
    SideNavigationVariant,
    Hero,
    WhyGitLabContent,
    ProofPoints,
  },
  asyncData({ i18n }) {
    const client = getClient();
    const locale = convertToCaseSensitiveLocale(i18n.locale);

    return client
      .getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'sys.id': '4LVFX3B1n3bmhETPX5ihL5',
        include: 10,
        locale,
        [`fields.description.${locale}[exists]`]: true,
      })
      .then(({ items: [{ fields }] }) => {
        return {
          data: fields.pageContent,
          seo: fields.seoMetadata[0].fields,
          links: fields.pageContent[1].fields.anchors.map((item) => ({
            title: item.fields.linkText,
            href: item.fields.anchorLink,
          })),
        };
      })
      .catch((e) => {
        throw new Error(e);
      });
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).seo, this.$route.path);
  },
  methods: {
    formatName(name) {
      if (name.author === undefined) {
        return null;
      }
      if (name.authorTitle === undefined) {
        return `– ${name.author}`;
      } else {
        return `${name.author}, ${name.authorTitle}, ${name.authorCompany}`;
      }
    },
  },
});
</script>

<template>
  <BackgroundWrapper>
    <SlpContainer>
      <Hero
        :small-text="data[0].fields.title"
        :title="data[0].fields.subheader"
        :description="data[0].fields.description"
        :cta="data[0].fields.primaryCta"
      />
    </SlpContainer>
    <SideNavigationVariant
      :dark-mode="true"
      data-slippers-scroll-darkmode
      :links="links"
    >
      <div
        v-for="(item, index) in data[2].fields.blocks"
        :id="links[index].href.replace('#', '')"
        :key="item.fields.internalName"
        data-slippers-scroll-darkmode="true"
      >
        <WhyGitLabContent
          :header="item.fields.header"
          :subheader="item.fields.subheader"
          :body="item.fields.text"
        />
        <ProofPoints
          v-for="(point, key) in item.fields.blocks"
          :key="key"
          :image="
            point.fields.quote.fields.authorHeadshot?.fields?.image?.fields
              ?.file?.url
          "
          :upper-text="point.fields.description"
          :link="point.fields.quote.fields.cta?.fields?.externalUrl"
          :link-text="point.fields.quote.fields.cta?.fields?.text"
          :quote="true"
          :text="point.fields.quote.fields.quoteText"
          :name="formatName(point.fields.quote.fields)"
          :icon="point.fields.icon"
          :data-ga-name="point.fields.quote.fields.cta?.fields?.dataGaName"
        />
      </div>
    </SideNavigationVariant>
    <div style="padding-top: 164px">
      <NextStepAlt />
    </div>
  </BackgroundWrapper>
</template>
